<?php

namespace Importacao\Logic\Integracao\Mastermaq\Classes;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Migracao;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Entities\EscalaTrabalho;

/**
 * Description of GeraEscalaTrabalho
 *
 * @author matheussilva
 */
class GeraEscalaTrabalho extends Migracao 
{
    
    public function __construct($path) 
    {
        parent::__construct($path);
        $this->file_name = "EscalaTrabalho";
        $this->setColumns();
    }

    private function  retHorDia($ini, $alm, $vAlm, $said)
    {
        $intervaloAlmoco   = $alm->diff($vAlm);
        $intervaloTrabalho = $ini->diff($said);
        $intervaloTrabalho->invert = 0;
        $intervaloAlmoco->invert   = 0;
        
        $dataBase = new \DateTime();
        $dataBase1 = new \DateTime();

        $dataBase->add($intervaloTrabalho);
        if( $intervaloAlmoco->h >= 1 )
        $dataBase->sub($intervaloAlmoco);

        return $dataBase->diff($dataBase1);
         
    }

    private function tratarInfoNula($array)
    {
        $new = array();

        $n = count($array);

        for ($c=0; $c < $n; $c++) { 
            $array[$c]["DIA_SEMANA"] = "";
        }

        for ($i=0; $i < $n-1; $i++) { 
            if(($array[$i] !== $array[$i+1])&&($array[$i+1]["IN_NORMAL"] != ":")&&($array[$i+1]["FIM_NORMAL"] != ":")&&($array[$i+1]["IN_NORMAL"] != "00:00")) {
                $new[] = $array[$i+1];
            }
        }

        return $new;
    }

    public function createInfo($info) {
        
        $info = $this->tratarInfoNula($info);
        $c = "0";

        foreach ($info as $reg) {
            $time = new EscalaTrabalho();

            $entr = new \DateTime("01/01/1900 ".$reg["IN_NORMAL"].":00");
            $alm = new \DateTime("01/01/1900 ".(($reg["IN_ALMOCO"]==":")?"00:00":$reg["IN_ALMOCO"]).":00");
            $volt = new \DateTime("01/01/1900 ".(($reg["FIM_ALMOCO"]==":")?"00:00":$reg["FIM_ALMOCO"]).":00");
            $said = new \DateTime("01/01/1900 ".$reg["FIM_NORMAL"].":00");

            $time->setInicio_vigencia('01/01/2000');
            $time->setNr_escala((string)$c);
            $time->setNome($entr->format("H:i")." AS ". $said->format("H:i"));
            $time->setPrimeira_entrada($entr->format("H:i:s"));
            $time->setPrimeira_saida($alm->format("H:i:s"));
            $time->setSegunda_entrada($volt->format("H:i:s"));
            $time->setSegunda_saida($said->format("H:i:s"));
            $hrTrab = $this->retHorDia($entr, $alm, $volt, $said);
            $time->setJornada_diaria($hrTrab->format("%h:%I"));
            $time->setCompetencia("01/01/2000");

            $this->objects[] = $time;
            $c++;
        }

    }
    
    public function setColumns() {
        $this->columns[] = 'Início Vigência';
        $this->columns[] = 'Nr Escala';
        $this->columns[] = 'Jornada Diária';
        $this->columns[] = 'Competência';
        $this->columns[] = 'Nome';
        $this->columns[] = '1 Entrada';
        $this->columns[] = '1 Saida';
        $this->columns[] = '2 Entrada';
        $this->columns[] = '2 Saida';
        $this->columns[] = 'Descanso Semanal';
    }

}

?>
