IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FASEORCOPERAC'   AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_FASEORCOPERAC
GO


CREATE TRIGGER LOG_FASEORCOPERAC
ON FASEORCOPERAC
FOR INSERT, DELETE, UPDATE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO   VARCHAR(1);

   DECLARE  @V_OLD_CDFASEORCOPERAC VARCHAR(10);
   DECLARE  @V_OLD_NMFASEORCOPERAC VARCHAR(100);
   DECLARE  @V_OLD_NRDIASALERTA    DOUBLE PRECISION;
   DECLARE  @V_OLD_IDFASECALCORCA  VARCHAR(1);
   DECLARE  @V_OLD_IDFASEAPROVORCA VARCHAR(1);

   DECLARE  @V_NEW_CDFASEORCOPERAC VARCHAR(10);
   DECLARE  @V_NEW_NMFASEORCOPERAC VARCHAR(100);
   DECLARE  @V_NEW_NRDIASALERTA    DOUBLE PRECISION;
   DECLARE  @V_NEW_IDFASECALCORCA  VARCHAR(1);
   DECLARE  @V_NEW_IDFASEAPROVORCA VARCHAR(1);

BEGIN

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDFASEORCOPERAC,
      NMFASEORCOPERAC,
      NRDIASALERTA,
      IDFASECALCORCA,
      IDFASEAPROVORCA,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE CDFASEORCOPERAC NOT IN (SELECT CDFASEORCOPERAC FROM INSERTED)

   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDFASEORCOPERAC,
      DELETED.NMFASEORCOPERAC,
      DELETED.NRDIASALERTA,
      DELETED.IDFASECALCORCA,
      DELETED.IDFASEAPROVORCA,

      INSERTED.CDFASEORCOPERAC,
      INSERTED.NMFASEORCOPERAC,
      INSERTED.NRDIASALERTA,
      INSERTED.IDFASECALCORCA,
      INSERTED.IDFASEAPROVORCA
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDFASEORCOPERAC = DELETED.CDFASEORCOPERAC
   UNION ALL

   SELECT
      'I' IDCOMANDO,

      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDFASEORCOPERAC,
      NMFASEORCOPERAC,
      NRDIASALERTA,
      IDFASECALCORCA,
      IDFASEAPROVORCA
   FROM
      INSERTED
   WHERE CDFASEORCOPERAC NOT IN (SELECT CDFASEORCOPERAC FROM DELETED)
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDFASEORCOPERAC,
                                 @V_OLD_NMFASEORCOPERAC,
                                 @V_OLD_NRDIASALERTA,
                                 @V_OLD_IDFASECALCORCA,
                                 @V_OLD_IDFASEAPROVORCA,
                                 @V_NEW_CDFASEORCOPERAC,
                                 @V_NEW_NMFASEORCOPERAC,
                                 @V_NEW_NRDIASALERTA,
                                 @V_NEW_IDFASECALCORCA,
                                 @V_NEW_IDFASEAPROVORCA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDFASEORCOPERAC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdFase=' + @V_OLD_CDFASEORCOPERAC;
         END;
         IF @V_OLD_NMFASEORCOPERAC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NmFase=' + @V_OLD_NMFASEORCOPERAC;
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDFASEORCOPERAC;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN
            IF (@V_OLD_NMFASEORCOPERAC <> @V_NEW_NMFASEORCOPERAC) BEGIN
               SET @V_DESC = @V_DESC + ' NmFase=' + @V_NEW_NMFASEORCOPERAC;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFASEORCOPERAC;
            END;

            IF (@V_OLD_NRDIASALERTA <> @V_NEW_NRDIASALERTA) BEGIN
               SET @V_DESC = @V_DESC + ' NumDias=' + CONVERT(VARCHAR,@V_NEW_NRDIASALERTA);
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFASEORCOPERAC;
            END;

            IF (@V_OLD_IDFASECALCORCA <> @V_NEW_IDFASECALCORCA) BEGIN
               SET @V_DESC = @V_DESC + ' IdFaseCalc=' + @V_NEW_IDFASECALCORCA;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFASEORCOPERAC;
            END;

            IF (@V_OLD_IDFASEAPROVORCA <> @V_NEW_IDFASEAPROVORCA) BEGIN
               SET @V_DESC = @V_DESC + ' IdFaseAprov=' + @V_NEW_IDFASEAPROVORCA;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFASEORCOPERAC;
            END;

         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDFASEORCOPERAC;

            IF ISNULL(@V_NEW_CDFASEORCOPERAC,'!') <> ISNULL(@V_OLD_CDFASEORCOPERAC,'!') BEGIN
               SET @V_DESC = @V_DESC + ' CdFase=' + @V_NEW_CDFASEORCOPERAC;
            END;

            IF ISNULL(@V_NEW_NMFASEORCOPERAC ,'!') <> ISNULL(@V_OLD_NMFASEORCOPERAC, '!') BEGIN
               SET @V_DESC = @V_DESC + ' NmFase=' + @V_NEW_NMFASEORCOPERAC;
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('FASEORCOPERAC',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDFASEORCOPERAC,
                                    @V_OLD_NMFASEORCOPERAC,
                                    @V_OLD_NRDIASALERTA,
                                    @V_OLD_IDFASECALCORCA,
                                    @V_OLD_IDFASEAPROVORCA,
                                    @V_NEW_CDFASEORCOPERAC,
                                    @V_NEW_NMFASEORCOPERAC,
                                    @V_NEW_NRDIASALERTA,
                                    @V_NEW_IDFASECALCORCA,
                                    @V_NEW_IDFASEAPROVORCA;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FASEORCOPERAC','5.09.000';
GO

